# -*- coding: utf-8 -*-
first_name = '' # TODO
last_name = '' # TODO
hand_in = False # TODO: set to True and run again before hand_in. Hand_in also the output* file

import sys
import os
if hand_in:
    filename = os.path.basename(__file__).split('.')[0]
    output = open(f'output_{filename}_{last_name}_{first_name}.txt', 'w')
    sys.stdout = output
    print(f"{filename}\n {last_name}, {first_name}")


import numpy as np
import matplotlib.pyplot as plt
from scipy.integrate import solve_ivp
import scipy.optimize



# TODO vervollständigen Sie das Template.



def simulate_pendulum(initial_angle, t_end):
    """Berechnet die approximative Loesung der Pendelgleichung.

    Berechnet eine genaue Approximation der Pendelgleichung zur Zeit `t_end`,
    mit den Anfangsbedingungen:
        y0[0] = initial_angle
        y0[1] = 0.0

    Der ODE-Loeser ist `solve_ivp`.

        initial_angle : Skalar. Auslenkung zur Zeit t = 0.
                t_end : Endzeit der Simulation.

    """

    # TODO vervollständigen Sie das Template.

    return np.linspace(0, t_end, 10), np.zeros((2, 10)) # Bitte ersetzen.



# TODO vervollständigen Sie das Template.

def plot_pendulum(t, y, c, phi):
    """Plotte Winkel und Winkelgeschwindigkeit als Funktion der Zeit.

      t : 1D Array. Zeit.
      y : 2D Array. Loesung der Pendelgleichung.
          Achse 0: Zeit.
          Achse 1: Winkel, Winkelgeschindigkeit
      c : Farbe (color) des Graphen, 'b', 'r', 'g', 'c', etc.
    phi : Anfangsauslenkung des Pendels.
    """

    phi_str = "{:1.2f}".format(phi / (0.5 * np.pi))
    phi_label = r"$\phi \, | \, \phi_0 = " + phi_str + r"\, \frac{\pi}{2}$"
    dphidt_label = (
        r"$\frac{d\phi}{dt} \, | \, \phi_0 = " + phi_str + r"\, \frac{\pi}{2}$"
    )

    plt.plot(t, y[0], c, label=phi_label)
    plt.plot(t, y[1], c + "--", label=dphidt_label)


def savefig(filename):
    """ Speichert den aktuellen matplotlib Plot als 'eps' und 'png'. """

    plt.savefig(filename + ".eps", dpi=300, bbox_inches="tight")
    plt.savefig(filename + ".png", dpi=300, bbox_inches="tight")


def plot_root(phi_star, plotname):
    """Erstellt einen Plot um die Lösung von d) - f) zuüberprüfen.

    phi_star: Anfangswinkel für den die Periode 1.8s ist.
    plotname: Der Dateiname (ohne Endung) der Plots
    """

    fig = plt.figure()

    t_end = 1.8
    t3, y3 = simulate_pendulum(phi_star, t_end)
    plot_pendulum(t3, y3, "g", phi_star)
    plt.legend(loc="upper left")
    savefig(plotname)

    plt.close(fig)



# TODO vervollständigen Sie das Template.

